MODEL FACPLAN
!
TABLES
!
 DIMM(5)
!
DISKDATA
!
 DIMM(1)= facplan.dim
!
LET IMAX = DIMM(1)   !  Tidsperiode definert i 12.3
LET MMAX = DIMM(2)   !  Maskin
LET PMAX = DIMM(3)   !  Produkt
LET IIMAX= DIMM(4)   !  Tidsperiode definert i 12.3
LET IOP  = DIMM(5)   !  Indikator som angir hvorvidt 12.3(0) eller 12.4(1)  
!
TABLES
!
 PROFIT(PMAX)       
 TIME(MMAX,PMAX)    !   Tid hver maskin bruker p hvert produkt
 MARKLIM(IMAX,PMAX) !   Markedsettersprsel
 MASTOT(IMAX,MMAX)  !   Totalt antall maskiner
 WHOUR(3)           !   Matrise med data knyttet til arbeidstimer      
 NR3DOW(IMAX,MMAX)  !   Antall maskiner nede i 12.3
 NR4DOW(MMAX)       !   Antall maskiner nede i 12.4 
 STSTOCK(PMAX)      !   Startlager i periode 1 
 ENDSTOCK(PMAX)     !   Sluttlager i siste periode
 CONST(2)           !   1: Lagerrente, 2: Maxlager
!
DISKDATA
!
 PROFIT(1)= facplan.pro
 TIME(1,1)= facplan.tim
 MARKLIM(1,1)= facplan.mar
 MASTOT(1,1)= facplan.mas
 WHOUR(1)=facplan.who 
 NR3DOW(1,1)=facplan.nr3 
 NR4DOW(1)=facplan.nr4
 STSTOCK(1)=facplan.sts
 ENDSTOCK(1)=facplan.end
 CONST(1)=facplan.con
!
LET TOTHOUR=WHOUR(1)* WHOUR(2)* WHOUR(3) ! Tot antall arbeidstimer per mnd.
!
IF IOP.eq.1           
   LET IMAX=IIMAX    
ENDIF 
!
VARIABLES
!
 madow(i=1:IMAX,m=1:MMAX|IOP.eq.1)       !   Maskiner nede. Kun i 12.4
 sold(i=1:IMAX,p=1:PMAX)
 prod(i=1:IMAX,p=1:PMAX)
 stock(i=1:IMAX-1,p=1:PMAX)              !   Lager i slutten av periode
!
CONSTRAINTS
!
 MAXOBJ:				&
 	SUM(i=1:IMAX,p=1:PMAX)PROFIT(p)*sold(i,p) & 	      ! Inntekt 
              -SUM(i=1:IMAX-1,p=1:PMAX)CONST(1)*stock(i,p)& ! 
	-SUM(p=1:PMAX|IOP.eq.0) CONST(1)*ENDSTOCK(p)&         ! Lagerrente
              +SUM(p=1:PMAX)CONST(1)*STSTOCK(p) $           !
!
 STOCK(i=1:IMAX,p=1:PMAX):	&                             !
	SUM(|i.ne.1)stock(i-1,p) &                            ! 
             +prod(i,p) &                                   !
             -sold(i,p) &                                   ! Lagerrestriks.
             -SUM(|i.ne.IMAX)stock(i,p)= &                  !
             -SUM(|i.eq.1)STSTOCK(p) &                      !
             +SUM(|i.eq.IMAX)ENDSTOCK(p)                    !
! 
IF IOP.eq.0
 TIMECON(m=1:MMAX,i=1:IMAX):		&                       !
	SUM(p=1:PMAX) TIME(m,p)*prod(i,p)&                    ! Tidsrestriks.
	 < TOTHOUR*MASTOT(i,m)-TOTHOUR*NR3DOW(i,m)            ! 12.3
ELSE
 TIMECON(m=1:MMAX,i=1:IMAX):		&                       !
	SUM(p=1:PMAX) TIME(m,p)*prod(i,p)&                    ! Tidsrestriks.
	 < TOTHOUR*MASTOT(i,m) -TOTHOUR*madow(i,m)            ! 12.4
 !
  MAIN(m=1:MMAX): 	&	                                    ! Maskinbalanse
              SUM(i=1:IIMAX)madow(i,m)=NR4DOW(m)            ! 12.4
ENDIF
!
BOUNDS
!
     madow(i=1:IMAX,m=1:MMAX) .UI. min(MASTOT(i,m),NR4DOW(m))
 sold(i=1:IMAX,p=1:PMAX) < MARKLIM(i,p)
 stock(i=1:IMAX-1,p=1:PMAX) < CONST(2)
! 
GENERATE

!
TABLES 
   TAB1(PMAX)
   TAB2(IMAX)
   TAB3(MMAX)
!
IF IOP.eq.0
!
!Dette under frem til ELSE gjelder for problem 12.3
!
PRINT
!Mlfunksjonsverdi, profitt i pund
MAXOBJ
!   
ASSIGN TAB1(p=1:PMAX)=prod(1,p)
PRINT
!Mengde produsert i periode 1
    TAB1
!
ASSIGN TAB1(p=1:PMAX)=sold(1,p)
PRINT
!Mengde solgt i periode 1
   TAB1
!
ASSIGN TAB1(p=1:PMAX)=stock(1,p)
PRINT
!Mengde lagret i periode 1
  TAB1
!
ASSIGN TAB1(p=1:PMAX)=dj(prod(1,p))
PRINT 
!Reduserte kostnader for alle produkter i periode 1
   TAB1
!
ASSIGN TAB2(i=1:IMAX)=dual(TIMECON(1,i))
PRINT
!Skyggepriser for kapasiteten p "grinderen" i alle perioder
  TAB2
!
QUIT
!
ELSE
!
PRINT
!Mlfunksjonsverdi, profitt i pund
MAXOBJ
!
ASSIGN TAB3(m=1:MMAX)=madow(2,m)
PRINT
!Antall maskiner ute av drift i periode 2
  TAB3
!
QUIT
!
ENDIF


